/*
        XX    X    X  X    X  XXXXXX  X    X  XXXXXX
       X  X   XX   X  XX   X  X        X  X   X
      X    X  X X  X  X X  X  XXXXX     XX    XXXXX
      XXXXXX  X  X X  X  X X  X         XX    X
      X    X  X   XX  X   XX  X        X  X   X
      X    X  X    X  X    X  XXXXXX  X    X  XXXXXX
*/

#declare SX_annexe =  9.60;
#declare SY_annexe =  9.20;
#declare SZ_annexe = 13.10;

/*    ======================================================    */

#declare Les_Formes_Exemples = object
{
union	{
	object { Forme_Exemple_0 rotate -y*90 translate -5*z	}
	object { Forme_Exemple_1 rotate -y*93 translate -2.5*z 	}
	union	{
		object { Forme_Exemple(Texture_Exemple)  }
		object { Base_Forme_Exemple }
		rotate -y*90
		}
	object { Forme_Exemple_3 rotate -y*87 translate  2.5*z 	}
	object { Forme_Exemple_4 rotate -y*91 translate  5*z 	}
	object { Forme_Exemple_5 rotate -y*60 translate  <-2.3, 0, 7.333> }


	#local Ex = -3.10;
        #local H  =  4.55;
	object { Lampe_Spot_1	rotate -y*90 rotate -z*45 
				translate <Ex, H, -5>	}
	object { Lampe_Spot_1	rotate -y*90 rotate -z*45 
				translate <Ex, H, -2.5>	}

	object { Lampe_Spot_1	rotate -y*90 rotate -z*45 
				translate <Ex, H,  0>	}

	object { Lampe_Spot_1	rotate -y*90 rotate -z*45
				translate <Ex, H,  3>	}
	object { Lampe_Spot_1	rotate -y*90 rotate -z*45
				translate <Ex, H,  5>	}

	object { Lampe_Spot_1	rotate -y*80 rotate -z*45
				translate <Ex-2.5, H,  7.10>	}
	}
}
/*    ======================================================    */


#declare Anarchist_Mustache = object
{
union	{
	#local Epp    = 0.08;
	#local Deltas = <0.16, 0, 0>;

	text { ttf "Fonts/AnarchistMustache.ttf" , "Anarchist", Epp, Deltas
			translate <0.0, 1.14, 0> }
	text { ttf "Fonts/AnarchistMustache.ttf", "Mustache", Epp, Deltas
			translate <0.6, 0.15, 0> }
	}
texture {
	#if (mod(clock, 55) > 19)
	  pigment { color Orange*0.70 }
	#else
	  pigment { color rgb <0.2, 0.2, 0.7> }
	#end
	finish { phong 0.29 emission 0.48 }
	}
translate -2.5*x
}

/*    ======================================================    */

#declare Annexe_Corners = object
{
#local EXb = SX_annexe + 0.30;
#local EZb = SZ_annexe + 0.30;

union	{
	object { Balise_Grise	translate <-EXb, 0, -EZb> }
	object { Balise_Grise	translate < EXb, 0, -EZb> }
	object { Balise_Grise	translate <-EXb, 0,  EZb> }
	object { Balise_Grise	translate < EXb, 0,  EZb> }
	}
}

#local M   = 0.55;
#local R   = 0.107;			// rayon des tubulures

#local SXA = SX_annexe - M;
#local SYA = SY_annexe - 2.05;
#local SZA = SZ_annexe - M;

#declare Annexe_base = object
{
box { <-SX_annexe, 0, -SZ_annexe>, <SX_annexe, H_trottoir, SZ_annexe> }
texture { Rust scale 51.60 }
}

#declare Annexe_poteau_a = object
{
union	{
	cylinder { <0, 0, 0>, <0, 0.35, 0>, R*3 }
	cone { <0, 0.35, 0>, R*3, <0, 0.40, 0>, R }
	cylinder { <0, 0, 0>, <0, SYA,  0>, R }
	}
}

#declare Annexe_element = object
{
union {
	/* verticales */
	object { Annexe_poteau_a translate <-SXA, 0, 0> }
	object { Annexe_poteau_a translate < SXA, 0, 0> }

	/* obliques */
	cylinder { <-SXA, SYA, 0>, <0, SY_annexe, 0>, R*0.70 }
	cylinder { < SXA, SYA, 0>, <0, SY_annexe, 0>, R*0.70 }

	/* la partie en T */
	cylinder { <SXA, SYA, 0>, <-SXA, SYA, 0>, R/2 }
	cylinder { <0, SYA, 0>,   <0, SY_annexe, 0>, R/2 }
	#local Ez = 0.11;
	cylinder { <0, SYA, -Ez>, <0, SYA, Ez>, R }
	cylinder { <0, SY_annexe, -Ez>, <0, SY_annexe, Ez>, R*1.7 }
	#undef Ez

	/* les deux bouts */
	#local Ex = SXA;
	#local Ez = 0.28;
	cylinder { <-Ex, SYA, -Ez>, <-Ex, SYA, Ez>, R*1.41 }
	cylinder { < Ex, SYA, -Ez>, < Ex, SYA, Ez>, R*1.41 }

	}
texture { TURQ_BOZO scale <4, 3, 4> rotate x*33 }
}

#declare Annexe_longerons= object
{
union	{
	cylinder { <0, SY_annexe, -SZA>, <0, SY_annexe, SZA>, R }
	cylinder { < SXA, SYA, -SZA>, < SXA, SYA, SZA>, R }
	cylinder { <-SXA, SYA, -SZA>, <-SXA, SYA, SZA>, R }
	}
texture { GRIS_BROTCH scale 3 }
}

/*    ------------------------------------------------------    */

#declare Plaque_de_Toit = object
{
box { <0.10, -0.01, -1.80>, <9, 0.01, 1.80> }
texture { TEINTE_BASIQUE scale <10, 1, 1> }
}

#declare Les_deux_plaques = object
{
union	{
	object { Plaque_de_Toit rotate -z*12 }
	object { Plaque_de_Toit rotate -z*12 scale <-1, 1, 1> }
	}
translate y*SY_annexe 
}

/*    ------------------------------------------------------    */

#declare Fond_Annexe = object
{
#local EppFA = 0.01;	

box { <-8.7, 0, -EppFA>, <8.7, 7, EppFA> }
texture { TEINTE_BASIQUE scale <1, 10, 1> }
}

/*    ------------------------------------------------------    */
#declare Avant_Annexe = object
{
#local EppFA = 0.06;	
#local Haa   = 1.50;

difference {
	box { <-8.00, 0, -EppFA>, <8.00, Haa, EppFA> }

	#local Hc = Haa / 2;
	// cylinder { <-7, Hc, -1>, <-7, Hc, 1>, 0.40 }
	// cylinder { < 7, Hc, -1>, < 7, Hc, 1>, 0.40 }
	#undef Hc

	text { ttf "Fonts/COOLFONT.TTF" "<+> DINORAMA <+>"
			1.60, <0.25, 0.0, 0.0>
			scale <1.15, 1.62, 1.06> 
			translate <-6.00, 0.30, -0.90>
			}
	}
texture { ROSE_BIZARRE scale 30 translate x*(24*NormClock) }
rotate y*180
}

/*    ------------------------------------------------------    */

#declare Croisillon_annexe = object
{
#local Ha = 1.1;
#local Hb = -Ha;
union	{
	cylinder { < 0, Ha,  2>, < 0, Hb, -2>, 0.05 }
	cylinder { < 0, Hb,  2>, < 0, Ha, -2>, 0.05 }
	}
texture { TURQ_BOZO scale <4, 3, 4> rotate x*77 }
// pigment { color Cyan }
}
/*    ------------------------------------------------------    */

#declare Annexe_Charpente = object
{
merge	{

	object { Annexe_element translate -z*4			}
	object { Annexe_element translate -z*8			}
	object { Annexe_element translate -z*12			}
	object { Annexe_element					}
	object { Annexe_element translate  z*4 			}
	object { Annexe_element translate  z*8			}
	object { Annexe_element translate  z*12			}

	#local XA = SX_annexe / 2;
	#local YA = 5.68;
 	object { Croisillon_annexe translate <-SXA, YA, -10>	}
 	object { Croisillon_annexe translate <-SXA, YA,  -6>	}
	object { Croisillon_annexe translate <-SXA, YA,  -2>	}
 	object { Croisillon_annexe translate <-SXA, YA,  10>	}
 	object { Croisillon_annexe translate <-SXA, YA,   6>	}
	object { Croisillon_annexe translate <-SXA, YA,   2>	}

	object { Croisillon_annexe translate < SXA, YA,  -2>	}
	object { Croisillon_annexe translate < SXA, YA,  -6>	}
	object { Croisillon_annexe translate < SXA, YA, -10>	}
	object { Croisillon_annexe translate < SXA, YA,   2>	}
	object { Croisillon_annexe translate < SXA, YA,   6>	}
	object { Croisillon_annexe translate < SXA, YA,  10>	}

	object { Les_deux_plaques translate -z*10		}
	object { Les_deux_plaques translate  z*10		}
	object { Les_deux_plaques translate -z*6		}
	object { Les_deux_plaques translate  z*6		}
	object { Les_deux_plaques translate -z*2		}
	object { Les_deux_plaques translate  z*2		}

	object { Annexe_longerons				}

	object { Fond_Annexe  translate -z*(SZ_annexe-0.45)	}
	object { Avant_Annexe translate <0, 5.45, SZ_annexe-0.95> }

	}

}

#declare Lampes_Annexe = object
{
#local EL = 3.14159;
#local EZ = 5.00000;
union	{
	object { Lampe_Cube_2(Gray80) rotate -y*24 translate <-EL, 0,  EZ> }
	object { Lampe_Cube_2(Gray80) rotate  y*24 translate < EL, 0,  EZ> }
	object { Lampe_Boule_Blanche	translate < EL, -0.15, -EZ> }
	object { Lampe_Boule_Blanche	translate <-EL, -0.15, -EZ> }
	}
translate y*(SY_annexe-2.21)
}

/*    ------------------------------------------------------    */

#declare EcranAnnexe = object
{
#declare IMNUM = mod((clock+133), 480);
#declare INAME = concat("frames/fraktal/", str(IMNUM, -5, 0), ".pnm");

union	{
	box { <-3.2, 0.03, -2.4>, <3.2, -0.04, 2.4>
		pigment {
	        image_map { ppm INAME  }
	        rotate x*90
	        translate <-0.5, 0, -0.5>
        	scale <-6.4, 1, 4.8> }
		finish { emission 0.75 }
		}
	box { <-3.4, 0.03, -2.6>, <3.4, 0.04, 2.6>
		pigment { color Yellow*0.666 } }
        }
rotate -x*90
}

/*    ------------------------------------------------------    */

#declare Annexe_meubles = object
{
union	{
	#local eX = SX_annexe - 1.80;
	#local eZ = SZ_annexe - 3.90;
	object {  Petit_Banc(Magenta) rotate y*4 translate < eX, 0,  eZ> }
	object {  Une_Table			translate <-eX, 0,  eZ> }
	object {  Une_Table			translate < eX, 0, -eZ> }
	object {  Chaise_Jaune rotate y*12	translate <-eX, 0, -eZ>	}
	}
}

/*    ------------------------------------------------------    */

#declare Annexe = object
{
union	{
	// object { Annexe_Corners }
	object { Annexe_base }
	object { EcranAnnexe translate <0, 3.20, -12.40> }
	object { Annexe_Charpente }
	object { Lampes_Annexe }
	object { Annexe_meubles translate y*H_trottoir }

	object { Les_Formes_Exemples
		translate <(SX_annexe-1.45), H_trottoir, 0> }

	object { Gros_Truc  rotate -y*12 translate y*H_trottoir }

	object { Anarchist_Mustache scale <2.82, 2, 2> rotate -y*90
				translate <-(SX_annexe - 1.80), 2.50, 1.2> }
	}
}
